package org.jeecg.modules.system.app.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.app.entity.ShopMoneyHis;
import org.jeecg.modules.system.app.service.IShopMoneyHisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
 /**
 * @Description: 变化历史记录表
 * @Author: jeecg-boot
 * @Date:   2025-08-18
 * @Version: V1.0
 */
@Tag(name="变化历史记录表")
@RestController
@RequestMapping("/shopMoneyHis/shopMoneyHis")
@Slf4j
public class ShopMoneyHisController extends JeecgController<ShopMoneyHis, IShopMoneyHisService> {
	@Autowired
	private IShopMoneyHisService shopMoneyHisService;
	
	/**
	 * 分页列表查询
	 *
	 * @param shopMoneyHis
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "变化历史记录表-分页列表查询")
	@Operation(summary="变化历史记录表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ShopMoneyHis>> queryPageList(ShopMoneyHis shopMoneyHis,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {


        QueryWrapper<ShopMoneyHis> queryWrapper = QueryGenerator.initQueryWrapper(shopMoneyHis, req.getParameterMap());
		Page<ShopMoneyHis> page = new Page<ShopMoneyHis>(pageNo, pageSize);
		IPage<ShopMoneyHis> pageList = shopMoneyHisService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param shopMoneyHis
	 * @return
	 */
	@AutoLog(value = "变化历史记录表-添加")
	@Operation(summary="变化历史记录表-添加")
	@RequiresPermissions("shopMoneyHis:nm_shop_money_his:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ShopMoneyHis shopMoneyHis) {
		shopMoneyHisService.save(shopMoneyHis);

		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param shopMoneyHis
	 * @return
	 */
	@AutoLog(value = "变化历史记录表-编辑")
	@Operation(summary="变化历史记录表-编辑")
	@RequiresPermissions("shopMoneyHis:nm_shop_money_his:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody ShopMoneyHis shopMoneyHis) {
		shopMoneyHisService.updateById(shopMoneyHis);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "变化历史记录表-通过id删除")
	@Operation(summary="变化历史记录表-通过id删除")
	@RequiresPermissions("shopMoneyHis:nm_shop_money_his:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		shopMoneyHisService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "变化历史记录表-批量删除")
	@Operation(summary="变化历史记录表-批量删除")
	@RequiresPermissions("shopMoneyHis:nm_shop_money_his:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.shopMoneyHisService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "变化历史记录表-通过id查询")
	@Operation(summary="变化历史记录表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ShopMoneyHis> queryById(@RequestParam(name="id",required=true) String id) {
		ShopMoneyHis shopMoneyHis = shopMoneyHisService.getById(id);
		if(shopMoneyHis==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(shopMoneyHis);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param shopMoneyHis
    */
    @RequiresPermissions("shopMoneyHis:nm_shop_money_his:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ShopMoneyHis shopMoneyHis) {
        return super.exportXls(request, shopMoneyHis, ShopMoneyHis.class, "变化历史记录表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("shopMoneyHis:nm_shop_money_his:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ShopMoneyHis.class);
    }

}
